/*===========================================================
 FILENAME     command.h
 VERSION      $Rev$

 DESCRIPTION  struct and consts for command
 AUTHOR       phk

 CHANGES
 Date       | Name             | Comment
 ------------------------------------------------------------
 2004-05-13 | phk              | Initial Version
 
=============================================================*/

#ifndef __IBRC_COMMAND_H
#define __IBRC_COMMAND_H

#include "common/types.h"

enum {
	/* server commands */
	IBRC_COMMAND_CONNECT = 0,
	IBRC_COMMAND_SERVERROR,
	IBRC_COMMAND_ERROR,

	/* channel commands */
	IBRC_COMMAND_JOIN,
	IBRC_COMMAND_LEAVE,
	IBRC_COMMAND_MSG,
	IBRC_COMMAND_NICKCHANGE,
	IBRC_COMMAND_TOPIC,
	IBRC_COMMAND_GETTOPIC,
	IBRC_COMMAND_LIST,
	IBRC_COMMAND_LISTREPLY,

	/* private command */
	IBRC_COMMAND_PRIVMSG,

	/* and a constant... */
	IBRC_COMMANDS_COUNT
};

extern char *ibrc_commands[IBRC_COMMANDS_COUNT];
extern char *ibrc_DELIMS;
extern char *ibrc_MSGEND;



#define IBRC_COMMANDS_MAX_PARAM_GROUPS 5

/** Command */
/** fields beginning with underscore are private */
typedef struct rCommand{
	int				command;

	int				rcvd_on_fd;

	trClient*			client;
	trChannel*			channel;

	union {
		struct {
			char*		cmdstr;
			char*		name;
			char*		errormsg;
		} servercmd;
		struct {
			char*		cmdstr;
			char*		nick;
			char*		channel;
			char*		argument;
		} channelcmd;
		struct {	
			char*		cmdstr;
			char*		nick;
			char*		channel;
			char*		recipient;
			char*		argument;
		} privatecmd;
			
		char*			_raw [IBRC_COMMANDS_MAX_PARAM_GROUPS];
	} params;

	char*				_full_cmdstr;
	char*				_split_cmdstr;
} trCommand;

#endif // __IBRC_COMMAND_H
