/*===========================================================
 FILENAME     types.h
 VERSION      0.1

 DESCRIPTION  Basic IBRC Types
 AUTHOR       Sonnenberg

 CHANGES
 Date       | Name             | Comment
 ------------------------------------------------------------
 2004-05-12 | Sonnenberg       | Initial Version
 
=============================================================*/

#ifndef __IBRC_TYPES_H
#define __IBRC_TYPES_H

/*----- General defines -----*/
#define IBRC_NICKLEN            9
#define IBRC_NAMELEN            12
#define IBRC_CHANNELLEN         13
#define IBRC_TOPICLEN           13
#define IBRC_MAXBUFFSIZE        512
#define IBRC_MAXSTRSIZE         80
#define IBRC_MAXNUMOFSERVER     10
#define IBRC_MAXNUMOFCLIENTS    20
#define IBRC_MAXNUMOFCHANNELS   100

#ifndef bool
typedef enum enBool { false, true } bool;
#define TRUE  true
#define FALSE false
#endif /* bool */

/*----------------------*/
/*----- IBRC Types -----*/
/*----------------------*/

/** Server */
typedef struct rServer{
  int       nSockFd;
} trServer;

/** Channel */
typedef struct rChannel{
  char      *name;
  char      *topic;
} trChannel;

/** Client */
typedef struct rClient{
  char      *nick;
  trChannel *channel;
  int       nSockFd;
} trClient;

#endif /* __IBRC_TYPES_H */
