#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h> /* open, close Fd */
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netdb.h>
#include "types.h"


int connectHost(char* hostname, int port){
  int nSocketFd;
  struct sockaddr_in rHostAddr;
  struct hostent *pHost;

  /* get host by name */
  if((pHost = (void*)gethostbyname(hostname)) == NULL) {
    perror("gethostbyname error");
    exit(1);
  }
  
  if(pHost->h_addrtype !=  AF_INET) {
    perror("Unknown address type");
    exit(1);
  }
  
  bzero((char *) &rHostAddr, sizeof(rHostAddr));
  rHostAddr.sin_family = AF_INET;
  rHostAddr.sin_addr.s_addr = 
    ((struct in_addr *)pHost->h_addr_list[0])->s_addr;
  rHostAddr.sin_port = htons(port);
  
  /* open a TCP socket */
  if((nSocketFd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("Error opening socket");
    exit(1);
  }

  /* connect to the host */    
  if(connect(nSocketFd, (struct sockaddr *) &rHostAddr, sizeof(rHostAddr)) < 0){
    perror("Error connecting host");
    exit(1);
  }
  return nSocketFd;
}
