#ifndef __HASHTABLE_H
#define __HASHTABLE_H

#define HASHTABLESIZE 10
#define HASHVALUE 31

typedef struct rHashtable{
  char key[255];
  void *val;
  struct rHashtable *prev;
  struct rHashtable *next;
} trHashtable;

/* "public" functions */
trHashtable *hash_table_insert(trHashtable **, char *, void *);

void *hash_table_lookup(trHashtable **, char *);

void hash_table_delEntry(trHashtable **, char *);

void hash_table_renameEntry(trHashtable **, char *, char*);

void hash_table_changeValue(trHashtable **, char *, void *);

void hash_table_free_values(trHashtable **);

void hash_table_free(trHashtable **);

void hash_table_free_inclKeys(trHashtable **);

/* "private" functions */
unsigned int hash_function(char *);

trHashtable *private_hash_lookup(trHashtable **, char *);


#endif /* __HASHTABLE_H */
