/*
  Example for use of hashtable.
  Compile with gcc -o hashmaptest ../hashtable.c hashmaptest.c
  (me was to lazy to write a Makefile for the tests...)
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "../hashtable.h"

int main()
{
  /* variables */
  trHashtable *phonebook[HASHTABLESIZE], *pEntry;
  int i, *aNumbers[6], *pNumber;

  /* initialization */
  for(i=0; i<HASHTABLESIZE; ++i) phonebook[i]=NULL;
  for(i=0; i<HASHTABLESIZE; ++i) aNumbers[i] = (int *)malloc(sizeof(int));;

  /* insert some content */
  *aNumbers[0]=8150;  hash_table_insert(phonebook,"Philipp", (void *)aNumbers[0]);
  *aNumbers[1]=8160;  hash_table_insert(phonebook,"Vitus", (void *)aNumbers[1]);
  *aNumbers[2]=8170;  hash_table_insert(phonebook,"Snoopy", (void *)aNumbers[2]);
  *aNumbers[3]=110;   hash_table_insert(phonebook,"C-Team", (void *)aNumbers[3]);
  *aNumbers[4]=111;   hash_table_insert(phonebook,"B-Team(?)", (void *)aNumbers[4]);
  *aNumbers[5]=112;   hash_table_insert(phonebook,"A-Team", (void *)aNumbers[5]);

  /* make some lookups */
  pNumber=(int*)hash_table_lookup(phonebook,"Philipp");
  if(pNumber!=NULL) printf("Lookup Philipps phone-nr: %d\n", *pNumber );
  pNumber=(int*)hash_table_lookup(phonebook,"Vitus");
  if(pNumber!=NULL) printf("Lookup Vitus phone-nr: %d\n", *pNumber );
  pNumber=(int*)hash_table_lookup(phonebook,"Snoopy");
  if(pNumber!=NULL) printf("Lookup Snoopys phone-nr: %d\n", *pNumber );

  /* make some data changes */
  printf("\nChanging Name of Vitus to VLM\n");
  hash_table_renameEntry(phonebook,"Vitus","VLM");
  printf("Deleting Snoopy");
  hash_table_delEntry(phonebook,"Snoopy");

  /* print whole hash_table */
  printf("\n\n--------------------------------------------------------\n");
  printf("Phonebook:\n");
  printf("--------------------------------------------------------\n");
  for(i=0; i<HASHTABLESIZE; ++i){
    pEntry = phonebook[i];
    while(pEntry != NULL){
      printf("%s ::= %d\n", pEntry->key, *(int *)pEntry->val);
      pEntry = pEntry->next;
    }
  }
  printf("--------------------------------------------------------\n");

  /* free everything */
  hash_table_free_values(phonebook);
  hash_table_free(phonebook);

  /* return success */
  return 0;
}
